# CharsetDecoder Class Reference

Inherits ObjectImpl.

List of all members.

## Detailed Description

An abstract engine to transform a sequences of bytes in a specific charset into a LogString.

## Public Member Functions

virtual | ~CharsetDecoder ()
| Destructor.
virtual log4cxx_status_t | decode (ByteBuffer &in, LogString &out)=0
| Decodes as many bytes as possible from the given input buffer, writing the results to the given output string.

## Static Public Member Functions

static CharsetDecoderPtr | getDefaultDecoder ()
| Get decoder for default charset.
static CharsetDecoderPtr | getDecoder (const LogString &charset)
| Get decoder for specified character set.
static CharsetDecoderPtr | getUTF8Decoder ()
| Get decoder for UTF-8.
static CharsetDecoderPtr | getISOLatinDecoder ()
| Get decoder for ISO-8859-1.
static bool | isError (log4cxx_status_t stat)
| Determins if status value indicates an invalid byte sequence.

## Protected Member Functions

| CharsetDecoder ()
| Protected constructor.

## Constructor & Destructor Documentation

CharsetDecoder | ( |  | ) | `[protected]`

| Protected constructor.

virtual ~CharsetDecoder | ( |  | ) | `[virtual]`

| Destructor.

## Member Function Documentation

virtual log4cxx_status_t decode | ( | ByteBuffer & | in,
|  | LogString & | out
| ) | `[pure virtual]`

Decodes as many bytes as possible from the given input buffer, writing the results to the given output string.

Parameters:

  | in | input buffer.
  | out | output string.

Returns:
  APR_SUCCESS if not encoding errors were found.

static CharsetDecoderPtr getDecoder | ( | const LogString & | charset | ) | `[static]`

Get decoder for specified character set.

Parameters:

  | charset | the following values should be recognized: "US-ASCII", "ISO-8859-1", "UTF-8", "UTF-16BE", "UTF-16LE".

Returns:
  decoder

Exceptions:

  | IllegalArgumentException | if charset is not recognized.

static CharsetDecoderPtr getDefaultDecoder | ( |  | ) | `[static]`

| Get decoder for default charset.

static CharsetDecoderPtr getISOLatinDecoder | ( |  | ) | `[static]`

| Get decoder for ISO-8859-1.

static CharsetDecoderPtr getUTF8Decoder | ( |  | ) | `[static]`

| Get decoder for UTF-8.

static bool isError | ( | log4cxx_status_t | stat | ) | `[inline, static]`

| Determins if status value indicates an invalid byte sequence.

The documentation for this class was generated from the following file:

- charsetdecoder.h